// Generated by rstantools.  Do not edit by hand.

#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#include <rstan/rstaninc.hpp>
// Code generated by Stan version 2.21.0
#include <stan/model/model_header.hpp>
namespace model_oneK_namespace {
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::prob_grad;
using namespace stan::math;
static int current_statement_begin__;
stan::io::program_reader prog_reader__() {
    stan::io::program_reader reader;
    reader.add_event(0, 0, "start", "model_oneK");
    reader.add_event(36, 34, "end", "model_oneK");
    return reader;
}
template <typename T1__, typename T2__>
Eigen::Matrix<typename boost::math::tools::promote_args<T1__, T2__>::type, Eigen::Dynamic, Eigen::Dynamic>
Cov(const int& N,
        const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& nugget,
        const T2__& gamma, std::ostream* pstream__) {
    typedef typename boost::math::tools::promote_args<T1__, T2__>::type local_scalar_t__;
    typedef local_scalar_t__ fun_return_scalar_t__;
    const static bool propto__ = true;
    (void) propto__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
    int current_statement_begin__ = -1;
    try {
        {
        current_statement_begin__ = 3;
        validate_non_negative_index("parCov", "N", N);
        validate_non_negative_index("parCov", "N", N);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> parCov(N, N);
        stan::math::initialize(parCov, DUMMY_VAR__);
        stan::math::fill(parCov, DUMMY_VAR__);
        current_statement_begin__ = 4;
        validate_non_negative_index("Nug_mat", "N", N);
        validate_non_negative_index("Nug_mat", "N", N);
        Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> Nug_mat(N, N);
        stan::math::initialize(Nug_mat, DUMMY_VAR__);
        stan::math::fill(Nug_mat, DUMMY_VAR__);
        current_statement_begin__ = 5;
        stan::math::assign(parCov, rep_matrix(gamma, N, N));
        current_statement_begin__ = 6;
        stan::math::assign(Nug_mat, diag_matrix(nugget));
        current_statement_begin__ = 7;
        stan::math::assign(parCov, add(parCov, Nug_mat));
        current_statement_begin__ = 8;
        return stan::math::promote_scalar<fun_return_scalar_t__>(parCov);
        }
    } catch (const std::exception& e) {
        stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
        // Next line prevents compiler griping about no return
        throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
    }
}
struct Cov_functor__ {
    template <typename T1__, typename T2__>
        Eigen::Matrix<typename boost::math::tools::promote_args<T1__, T2__>::type, Eigen::Dynamic, Eigen::Dynamic>
    operator()(const int& N,
        const Eigen::Matrix<T1__, Eigen::Dynamic, 1>& nugget,
        const T2__& gamma, std::ostream* pstream__) const {
        return Cov(N, nugget, gamma, pstream__);
    }
};
#include <stan_meta_header.hpp>
class model_oneK
  : public stan::model::model_base_crtp<model_oneK> {
private:
        int K;
        int N;
        int L;
        matrix_d obsCov;
        double varMeanFreqs;
        matrix_d LobsCov;
public:
    model_oneK(stan::io::var_context& context__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, 0, pstream__);
    }
    model_oneK(stan::io::var_context& context__,
        unsigned int random_seed__,
        std::ostream* pstream__ = 0)
        : model_base_crtp(0) {
        ctor_body(context__, random_seed__, pstream__);
    }
    void ctor_body(stan::io::var_context& context__,
                   unsigned int random_seed__,
                   std::ostream* pstream__) {
        typedef double local_scalar_t__;
        boost::ecuyer1988 base_rng__ =
          stan::services::util::create_rng(random_seed__, 0);
        (void) base_rng__;  // suppress unused var warning
        current_statement_begin__ = -1;
        static const char* function__ = "model_oneK_namespace::model_oneK";
        (void) function__;  // dummy to suppress unused var warning
        size_t pos__;
        (void) pos__;  // dummy to suppress unused var warning
        std::vector<int> vals_i__;
        std::vector<double> vals_r__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        try {
            // initialize data block variables from context__
            current_statement_begin__ = 12;
            context__.validate_dims("data initialization", "K", "int", context__.to_vec());
            K = int(0);
            vals_i__ = context__.vals_i("K");
            pos__ = 0;
            K = vals_i__[pos__++];
            check_greater_or_equal(function__, "K", K, 1);
            current_statement_begin__ = 13;
            context__.validate_dims("data initialization", "N", "int", context__.to_vec());
            N = int(0);
            vals_i__ = context__.vals_i("N");
            pos__ = 0;
            N = vals_i__[pos__++];
            check_greater_or_equal(function__, "N", N, 2);
            current_statement_begin__ = 14;
            context__.validate_dims("data initialization", "L", "int", context__.to_vec());
            L = int(0);
            vals_i__ = context__.vals_i("L");
            pos__ = 0;
            L = vals_i__[pos__++];
            check_greater_or_equal(function__, "L", L, (N + 1));
            current_statement_begin__ = 15;
            validate_non_negative_index("obsCov", "N", N);
            validate_non_negative_index("obsCov", "N", N);
            context__.validate_dims("data initialization", "obsCov", "matrix_d", context__.to_vec(N,N));
            obsCov = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N);
            vals_r__ = context__.vals_r("obsCov");
            pos__ = 0;
            size_t obsCov_j_2_max__ = N;
            size_t obsCov_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < obsCov_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < obsCov_j_1_max__; ++j_1__) {
                    obsCov(j_1__, j_2__) = vals_r__[pos__++];
                }
            }
            current_statement_begin__ = 16;
            context__.validate_dims("data initialization", "varMeanFreqs", "double", context__.to_vec());
            varMeanFreqs = double(0);
            vals_r__ = context__.vals_r("varMeanFreqs");
            pos__ = 0;
            varMeanFreqs = vals_r__[pos__++];
            // initialize transformed data variables
            current_statement_begin__ = 19;
            validate_non_negative_index("LobsCov", "N", N);
            validate_non_negative_index("LobsCov", "N", N);
            LobsCov = Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic>(N, N);
            stan::math::fill(LobsCov, DUMMY_VAR__);
            // execute transformed data statements
            current_statement_begin__ = 20;
            stan::math::assign(LobsCov, multiply(L, obsCov));
            // validate transformed data
            // validate, set parameter ranges
            num_params_r__ = 0U;
            param_ranges_i__.clear();
            current_statement_begin__ = 23;
            num_params_r__ += 1;
            current_statement_begin__ = 24;
            validate_non_negative_index("nugget", "N", N);
            num_params_r__ += N;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    ~model_oneK() { }
    void transform_inits(const stan::io::var_context& context__,
                         std::vector<int>& params_i__,
                         std::vector<double>& params_r__,
                         std::ostream* pstream__) const {
        typedef double local_scalar_t__;
        stan::io::writer<double> writer__(params_r__, params_i__);
        size_t pos__;
        (void) pos__; // dummy call to supress warning
        std::vector<double> vals_r__;
        std::vector<int> vals_i__;
        current_statement_begin__ = 23;
        if (!(context__.contains_r("gamma")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable gamma missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("gamma");
        pos__ = 0U;
        context__.validate_dims("parameter initialization", "gamma", "double", context__.to_vec());
        double gamma(0);
        gamma = vals_r__[pos__++];
        try {
            writer__.scalar_lb_unconstrain(0, gamma);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable gamma: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        current_statement_begin__ = 24;
        if (!(context__.contains_r("nugget")))
            stan::lang::rethrow_located(std::runtime_error(std::string("Variable nugget missing")), current_statement_begin__, prog_reader__());
        vals_r__ = context__.vals_r("nugget");
        pos__ = 0U;
        validate_non_negative_index("nugget", "N", N);
        context__.validate_dims("parameter initialization", "nugget", "vector_d", context__.to_vec(N));
        Eigen::Matrix<double, Eigen::Dynamic, 1> nugget(N);
        size_t nugget_j_1_max__ = N;
        for (size_t j_1__ = 0; j_1__ < nugget_j_1_max__; ++j_1__) {
            nugget(j_1__) = vals_r__[pos__++];
        }
        try {
            writer__.vector_lb_unconstrain(0, nugget);
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(std::runtime_error(std::string("Error transforming variable nugget: ") + e.what()), current_statement_begin__, prog_reader__());
        }
        params_r__ = writer__.data_r();
        params_i__ = writer__.data_i();
    }
    void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream__) const {
      std::vector<double> params_r_vec;
      std::vector<int> params_i_vec;
      transform_inits(context, params_i_vec, params_r_vec, pstream__);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r(i) = params_r_vec[i];
    }
    template <bool propto__, bool jacobian__, typename T__>
    T__ log_prob(std::vector<T__>& params_r__,
                 std::vector<int>& params_i__,
                 std::ostream* pstream__ = 0) const {
        typedef T__ local_scalar_t__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // dummy to suppress unused var warning
        T__ lp__(0.0);
        stan::math::accumulator<T__> lp_accum__;
        try {
            stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
            // model parameters
            current_statement_begin__ = 23;
            local_scalar_t__ gamma;
            (void) gamma;  // dummy to suppress unused var warning
            if (jacobian__)
                gamma = in__.scalar_lb_constrain(0, lp__);
            else
                gamma = in__.scalar_lb_constrain(0);
            current_statement_begin__ = 24;
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, 1> nugget;
            (void) nugget;  // dummy to suppress unused var warning
            if (jacobian__)
                nugget = in__.vector_lb_constrain(0, N, lp__);
            else
                nugget = in__.vector_lb_constrain(0, N);
            // transformed parameters
            current_statement_begin__ = 27;
            validate_non_negative_index("parCov", "N", N);
            validate_non_negative_index("parCov", "N", N);
            Eigen::Matrix<local_scalar_t__, Eigen::Dynamic, Eigen::Dynamic> parCov(N, N);
            stan::math::initialize(parCov, DUMMY_VAR__);
            stan::math::fill(parCov, DUMMY_VAR__);
            // transformed parameters block statements
            current_statement_begin__ = 28;
            stan::math::assign(parCov, Cov(N, nugget, gamma, pstream__));
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            current_statement_begin__ = 27;
            size_t parCov_j_1_max__ = N;
            size_t parCov_j_2_max__ = N;
            for (size_t j_1__ = 0; j_1__ < parCov_j_1_max__; ++j_1__) {
                for (size_t j_2__ = 0; j_2__ < parCov_j_2_max__; ++j_2__) {
                    if (stan::math::is_uninitialized(parCov(j_1__, j_2__))) {
                        std::stringstream msg__;
                        msg__ << "Undefined transformed parameter: parCov" << "(" << j_1__ << ", " << j_2__ << ")";
                        stan::lang::rethrow_located(std::runtime_error(std::string("Error initializing variable parCov: ") + msg__.str()), current_statement_begin__, prog_reader__());
                    }
                }
            }
            // model body
            current_statement_begin__ = 31;
            lp_accum__.add(normal_log<propto__>(nugget, 0, 1));
            current_statement_begin__ = 32;
            lp_accum__.add(normal_log<propto__>(gamma, varMeanFreqs, 0.5));
            current_statement_begin__ = 33;
            lp_accum__.add(wishart_log<propto__>(LobsCov, L, parCov));
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
        lp_accum__.add(lp__);
        return lp_accum__.sum();
    } // log_prob()
    template <bool propto, bool jacobian, typename T_>
    T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
               std::ostream* pstream = 0) const {
      std::vector<T_> vec_params_r;
      vec_params_r.reserve(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        vec_params_r.push_back(params_r(i));
      std::vector<int> vec_params_i;
      return log_prob<propto,jacobian,T_>(vec_params_r, vec_params_i, pstream);
    }
    void get_param_names(std::vector<std::string>& names__) const {
        names__.resize(0);
        names__.push_back("gamma");
        names__.push_back("nugget");
        names__.push_back("parCov");
    }
    void get_dims(std::vector<std::vector<size_t> >& dimss__) const {
        dimss__.resize(0);
        std::vector<size_t> dims__;
        dims__.resize(0);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N);
        dimss__.push_back(dims__);
        dims__.resize(0);
        dims__.push_back(N);
        dims__.push_back(N);
        dimss__.push_back(dims__);
    }
    template <typename RNG>
    void write_array(RNG& base_rng__,
                     std::vector<double>& params_r__,
                     std::vector<int>& params_i__,
                     std::vector<double>& vars__,
                     bool include_tparams__ = true,
                     bool include_gqs__ = true,
                     std::ostream* pstream__ = 0) const {
        typedef double local_scalar_t__;
        vars__.resize(0);
        stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
        static const char* function__ = "model_oneK_namespace::write_array";
        (void) function__;  // dummy to suppress unused var warning
        // read-transform, write parameters
        double gamma = in__.scalar_lb_constrain(0);
        vars__.push_back(gamma);
        Eigen::Matrix<double, Eigen::Dynamic, 1> nugget = in__.vector_lb_constrain(0, N);
        size_t nugget_j_1_max__ = N;
        for (size_t j_1__ = 0; j_1__ < nugget_j_1_max__; ++j_1__) {
            vars__.push_back(nugget(j_1__));
        }
        double lp__ = 0.0;
        (void) lp__;  // dummy to suppress unused var warning
        stan::math::accumulator<double> lp_accum__;
        local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
        (void) DUMMY_VAR__;  // suppress unused var warning
        if (!include_tparams__ && !include_gqs__) return;
        try {
            // declare and define transformed parameters
            current_statement_begin__ = 27;
            validate_non_negative_index("parCov", "N", N);
            validate_non_negative_index("parCov", "N", N);
            Eigen::Matrix<double, Eigen::Dynamic, Eigen::Dynamic> parCov(N, N);
            stan::math::initialize(parCov, DUMMY_VAR__);
            stan::math::fill(parCov, DUMMY_VAR__);
            // do transformed parameters statements
            current_statement_begin__ = 28;
            stan::math::assign(parCov, Cov(N, nugget, gamma, pstream__));
            if (!include_gqs__ && !include_tparams__) return;
            // validate transformed parameters
            const char* function__ = "validate transformed params";
            (void) function__;  // dummy to suppress unused var warning
            // write transformed parameters
            if (include_tparams__) {
                size_t parCov_j_2_max__ = N;
                size_t parCov_j_1_max__ = N;
                for (size_t j_2__ = 0; j_2__ < parCov_j_2_max__; ++j_2__) {
                    for (size_t j_1__ = 0; j_1__ < parCov_j_1_max__; ++j_1__) {
                        vars__.push_back(parCov(j_1__, j_2__));
                    }
                }
            }
            if (!include_gqs__) return;
        } catch (const std::exception& e) {
            stan::lang::rethrow_located(e, current_statement_begin__, prog_reader__());
            // Next line prevents compiler griping about no return
            throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***");
        }
    }
    template <typename RNG>
    void write_array(RNG& base_rng,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                     Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                     bool include_tparams = true,
                     bool include_gqs = true,
                     std::ostream* pstream = 0) const {
      std::vector<double> params_r_vec(params_r.size());
      for (int i = 0; i < params_r.size(); ++i)
        params_r_vec[i] = params_r(i);
      std::vector<double> vars_vec;
      std::vector<int> params_i_vec;
      write_array(base_rng, params_r_vec, params_i_vec, vars_vec, include_tparams, include_gqs, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i)
        vars(i) = vars_vec[i];
    }
    std::string model_name() const {
        return "model_oneK";
    }
    void constrained_param_names(std::vector<std::string>& param_names__,
                                 bool include_tparams__ = true,
                                 bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        param_name_stream__.str(std::string());
        param_name_stream__ << "gamma";
        param_names__.push_back(param_name_stream__.str());
        size_t nugget_j_1_max__ = N;
        for (size_t j_1__ = 0; j_1__ < nugget_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "nugget" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t parCov_j_2_max__ = N;
            size_t parCov_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < parCov_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < parCov_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "parCov" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
    }
    void unconstrained_param_names(std::vector<std::string>& param_names__,
                                   bool include_tparams__ = true,
                                   bool include_gqs__ = true) const {
        std::stringstream param_name_stream__;
        param_name_stream__.str(std::string());
        param_name_stream__ << "gamma";
        param_names__.push_back(param_name_stream__.str());
        size_t nugget_j_1_max__ = N;
        for (size_t j_1__ = 0; j_1__ < nugget_j_1_max__; ++j_1__) {
            param_name_stream__.str(std::string());
            param_name_stream__ << "nugget" << '.' << j_1__ + 1;
            param_names__.push_back(param_name_stream__.str());
        }
        if (!include_gqs__ && !include_tparams__) return;
        if (include_tparams__) {
            size_t parCov_j_2_max__ = N;
            size_t parCov_j_1_max__ = N;
            for (size_t j_2__ = 0; j_2__ < parCov_j_2_max__; ++j_2__) {
                for (size_t j_1__ = 0; j_1__ < parCov_j_1_max__; ++j_1__) {
                    param_name_stream__.str(std::string());
                    param_name_stream__ << "parCov" << '.' << j_1__ + 1 << '.' << j_2__ + 1;
                    param_names__.push_back(param_name_stream__.str());
                }
            }
        }
        if (!include_gqs__) return;
    }
}; // model
}  // namespace
typedef model_oneK_namespace::model_oneK stan_model;
#ifndef USING_R
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
#endif
#endif
